From be3247330f1fbaf669d25c73f74a0cbc0dec1056 Mon Sep 17 00:00:00 2001
From: Boris Smilga <boris.smilga@gmail.com>
Date: Thu, 17 Jan 2013 17:56:54 +0400
Subject: [PATCH] Set iteration var to null when evaluating result of DOLIST.

---
 src/macros.lisp     |    2 +-
 t/output-tests.lisp |    1 +
 2 files changed, 2 insertions(+), 1 deletions(-)

diff --git a/src/macros.lisp b/src/macros.lisp
index 5537872..4adfecd 100644
--- a/src/macros.lisp
+++ b/src/macros.lisp
@@ -391,7 +391,7 @@ lambda-list::=
                    (list (list arrvar array)))
            (,idx 0 (1+ ,idx)))
           ((>= ,idx (getprop ,arrvar 'length))
-           ,@(when result? (list result)))
+           ,@(when result? (list `(let ((,var nil)) ,result))))
        (setq ,var (aref ,arrvar ,idx))
        ,@body)))
 
diff --git a/t/output-tests.lisp b/t/output-tests.lisp
index 361cd8b..ae07b09 100644
--- a/t/output-tests.lisp
+++ b/t/output-tests.lisp
@@ -531,6 +531,7 @@ return alert('Sum of ' + l + ' is: ' + (function () {
         c = l[_js_idx1];
         s += c;
     };
+    var c = null;
     return s;
 })());
 })();")
-- 
1.7.5.4

